<?php
session_start();
// 文档名称
define('TITLE', 'API接口文档即时生成器');
// 登陆密码
define('PWD', '123456');

// 退出
if (isset($_GET['status']) && $_GET['status'] == 'out') {
    $_SESSION['apiword'] = '';
    echo '退出成功!';exit;
// 登陆
} else if (isset($_GET['status']) && $_GET['status'] == 'login') {
    if ($_POST['pwd'] == PWD) {
        $_SESSION['apiword'] = '1';
        echo 1;
    } else {
        echo 2;
    }
    exit;
// 参数转json
} else if (isset($_GET['status']) && $_GET['status'] == 'ajax_param') {
    $file = __DIR__."/param.php";
    $myfile = fopen($file, "w") or die('NO');
    fwrite($myfile, "<?php \r\n".$_POST['param']);
    fclose($myfile);
    $array = require_once $file;
    echo json_encode($array);
    exit;
}

function is_https() {
    if ( !empty($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS']) !== 'off') {
        return true;
    } elseif ( isset($_SERVER['HTTP_X_FORWARDED_PROTO']) && $_SERVER['HTTP_X_FORWARDED_PROTO'] === 'https' ) {
        return true;
    } elseif ( !empty($_SERVER['HTTP_FRONT_END_HTTPS']) && strtolower($_SERVER['HTTP_FRONT_END_HTTPS']) !== 'off') {
        return true;
    }
    return false;
}
// 接口跟地址
$url = $_SERVER['HTTP_HOST'].str_replace('index.php','', $_SERVER['REQUEST_URI']).'index.php/';
if (is_https()) {
    $url = 'https://'.$url;
} else {
    $url = 'http://'.$url;
}

// 需要生成的接口文档参数组
$list = [
    [
        'title' => '商品管理',
        'name' => 'shop',
        'list' => [
            [
                'title' => '新增',
                'name' => 'insert',
                'word' => '未编写'
            ],
            [
                'title' => '修改',
                'name' => 'update',
'word' => "return [
    // 请求头
    'header' => [
        'method' => 'POST', // 请求类型
        'code' => 'utf-8', // 内容编码
        'content-type' => 'application/x-www-form-urlencoded', // 数据类型
        // 其余自定义header
    ],
    // 请求参数
    'param' => [
        // 参考格式
        'name' => 'admin', // 账号 string(32) 默认null 不为空
        'pwd' => 'admin', // 密码 string(32) 默认null 不为空
    ],
    // 返回值
    'return' => [
        // 状态码囊括
        'code' => [
            200 => '请求成功', 
            301 => '接口错误',
            404 => '接口不存在',
        ],
        // data部分返回值说明
        'data' => [
            'name' => '1731223728', // 账号
            'sex' => '0', // 性别 0|1|2 未知|男|女
        ]
    ]
];"
            ]
        ]
    ],
];
?>

<!DOCTYPE html>
<html>
    <head>
        <meta charset="utf-8">
        <title><?php echo TITLE;?></title>
        <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
        <meta name="renderer" content="webkit">

        <link href="css/font-awesome.min.css" rel="stylesheet" type="text/css">
        <link rel="stylesheet" href="js/CodeMirror/codemirror.css">
        <link href="css/page.css?v=1.0.4" rel="stylesheet" type="text/css">

        <script src="https://www.jq22.com/jquery/jquery-2.1.1.js"></script>
        <script src="js/CodeMirror/codemirror.js"></script>
        <script src="js/CodeMirror/javascript.js"></script>

        <style>
        .skin-black .sidebar a {color: #1c5672;}pre{padding: 20px}
        .hide{display:none}
        .BLACKCOVER{z-index: 10;width:100%;height:100%;background-color:#000;opacity:.6;position:fixed;top:0;left:0;display:none}.bigShow{overflow-x: hidden;overflow-y: scroll;text-align: center;background: #fff;z-index: 9999999;position:fixed;top:0;left:0;width:100%;height:100%;padding:20px;box-shadow:1px 2px 3px #000;border-radius:15px;display:none}.bigShow span.close{position:absolute;width:100%;height:100%;right:0;top:0px;cursor:pointer}
        .bigShow img{display:none;}.codeLeft, .codeRight{width: 50%;float: left}
        .codeRight{background: #000;height: 170px;color: #fff}
        .codeRight div{margin: 10px}
        .codeTAB{width: 100%; background: #fff;text-align: right;float: left;}
        .codeTAB span {float: left;margin: 10px;}
        .codeTAB button{border: none;color: white;padding: 5px 16px;text-align: center;text-decoration: none;display: inline-block;font-size: 13px;border-radius: 4px;margin: 5px 5px 5px 0px;font-family: '微软雅黑';cursor: pointer}
        #codeAjax{background-color: #33b282;}
        #codeAjax:hover{background-color: #33af38;}
        #codeOut{background-color: #bababa;}
        #codeDiv{position: fixed;top: 0;z-index: 1000000000000;width: 100%;height: 100%;display: none}
        #codeDiv .cm-s-material{margin: 0}
        .Highlight2{color: #42b983;font-weight: bold;font-size: 15px;}
        .cm-s-material span.cm-comment,.cm-s-material .CodeMirror-linenumber {color: #9db3bd;}
        .content{padding-left:310px;max-width:100%}
        .content.with-sidebar {margin-left: 0px;}
        .ajax_api_btn,.ajax_api_btn2, .api_copy, .check_1, .check_2{border: 0;padding: 3px 5px;background: #42b983;color: #fff;border-radius: 5px;}
        .api_copy{background: #f44336;}
        .check_1{background: #db0096;}
        .check_2{background: #03a9f4;}
        
        @media screen and (max-width: 900px){
            .codeLeft, .codeRight{width: 100%;}
           .content{padding-left:0}
        }
        pre code{background: none}
        </style>

    </head>

    <body>

<?php if (!empty($_SESSION['apiword'])) { ?>
<div id="j_taskcenter" class="main">
 <div class="j_mainscroll mCus-mh100 scrollwrapper mCustomScrollbar _mCS_11 mCS_no_scrollbar">
  <div class="mCustomScrollBox mCS-darkblue mCSB_vertical mCSB_inside" id="mCSB_11" tabindex="0">
   <div dir="ltr" style="position:relative; top:0; left:0;" class="mCSB_container mCS_y_hidden mCS_no_scrollbar_y" id="mCSB_11_container">
    <div class="main-bd sidebar-in j_sidebarPren">
     <div class="table-tray scrollwrapper">
      <div class="main-content">


<div id="main" class="fix-sidebar">
    <div class="sidebar" style=" top: 0;">
        <div class="sidebar-inner">
            <div class="list">
                <a class="become-backer">文档列表</a>
                <a class="become-backer">已完成：<font color="red" id="yes">-</font></a><br/>

                <a class="become-backer" id="tab">切换列表-接口地址</a>
                <a class="become-backer">待完成：<font color="red" id="no">-</font></a><br/>

                <a class="become-backer" id="out">退出</a>
                <a class="become-backer">已对接：<font color="red" id="ok">-</font></a>
                <ul class="menu-root">
                    <?php $num = 0;?>
                    <?php foreach( $list as $k=>$v) { ?>
                    <?php $num++;?>
                    <li>
                        <a class="sidebar-link current" href="#A<?php echo $num;?>"><?php echo ($k+1).'、'.$v['title'];?></a>
                        <ul class="menu-sub">
                            <?php foreach( $v['list'] as $key=>$val) { ?>
                                <?php 
                                    $num++; 
                                    $md5 = md5(strtolower($v['name']).'/'.$val['name']).'.log';                                  
                                    $path1 = __DIR__."/php/check_1/";
                                    $path2 = __DIR__."/php/check_2/";
                                    $color = '';
                                    if (file_exists($path2.$md5)) {
                                        $color = "#03a9f4";
                                    } else if (file_exists($path1.$md5)) {
                                        $color = "#db0096";
                                    } if ($val['word'] == '未编写') {
                                        $color = "red";
                                    }
                                ?>
                                <li> <a class="section-link" id="B<?php echo $num;?>" href="#A<?php echo $num;?>" style="color:<?php echo $color;?>"><?php echo ($key+1).'、<span class="hide">'.strtolower($v['name']).'/'.$val['name'].'：</span>'.$val['title'];?></a></li>
                            <?php } ?>
                        </ul>
                    </li>
                    <?php } ?>
                </ul>
            </div>
        </div>
    </div>
    <div class="content guide with-sidebar index-guide">
        <h1><?php echo TITLE;?></h1>
        <p>该文档随着代码内部，自动更新。</p>

        <br/>
        <h1>接口根地址：</h1>
        <p>
            <code id="api_root"><?php echo $url; ?></code>
        </p>

        <?php $num = 0; $yes=0; $no=0;?>
        <?php foreach( $list as $k=>$v) { ?>
        <?php $num++;?>
            <h2 id="A<?php echo $num;?>"><?php echo ($k+1).'、'.$v['title'];?></h2>

            <?php foreach( $v['list'] as $key=>$val) { ?>
                <?php $num++;?>
                <?php
                if ($val['word'] == '未编写') {
                    $no++;
                } else {
                    $yes++;
                }
                ?>
                <h3 id="A<?php echo $num;?>"><?php echo ($key+1).'、'.$val['title'];?></h3>
                <p>
                    接口地址：<code id="D<?php echo $num;?>"><?php echo strtolower($v['name']).'/'.$val['name'];?></code>
                    <button class="api_copy" onclick="api_copy('<?php echo strtolower($v['name']).'/'.$val['name'];?>', this)">复制</button>
                    <button class="check_1" onclick="check_1('<?php echo $num;?>', this)">标记：进行中</button>
                    <button class="check_2" onclick="check_2('<?php echo $num;?>', this)">标记：已对接</button>
                    <button class="ajax_api_btn" data-id="D<?php echo $num;?>">调试接口</button>
                </p>
<textarea id="content<?php echo $num;?>"><?php echo $val['word'];?></textarea>
            <?php } ?>
            
        <?php } ?>
    </div>

</div>   


      </div>
     </div>
    </div>
   </div>
  </div>
 </div>
</div>

<!--复制文本框-->
<textarea id="inputBox" style="position: absolute;top: 0;left: 0;opacity: 0;z-index: -10;"></textarea>
<!--接口调试面板-->
<style>
.mask_div{display:none;position: fixed;right: 0;top: 0;z-index: 99999;background: #fff;border-left: 1px solid #ccc;width: 600px;height: 100%;overflow-y: auto;}
.mask_title{float: left;width: 100%;text-align: center;height: 50px;line-height: 50px;border-bottom: 1px solid #ccc;}
.mask_content{float: left;width: 100%;padding: 10px;}
#close{position: absolute;right: 10px; color:#42b983;cursor: pointer;}
#close:hover{color:red}
</style>
<div class="mask_div">
    <div class="mask_title">接口调试面板 <span id="close">关闭</span></div>  
    <div class="mask_content">
        
    </div>
</div>
<script>
function api_copy(txt, _this) {
    var copyBox = document.getElementById('inputBox');
    copyBox.value = txt;
    copyBox.select();
    document.execCommand('copy');
    $(_this).html('Copy OK！');
    setTimeout(function () {
        $(_this).html('复制');
    }, 1200);
}
function check_1(id, _this) {
    var url = $('#D'+id).html();
    $.ajax({
        type: 'post',
        data:{url:url},
        url: "php/check_1.php",
        success: function(data) {
            if (data == 'YES') {
                $(_this).html('标记成功！');
                setTimeout(function () {
                    $(_this).html('标记：进行中');
                }, 1200);

                var color = $('#B'+id).css('color');
                if (color == 'rgb(219, 0, 150)') {
                    $('#B'+id).css('color', '#34495e');
                } else {
                    $('#B'+id).css('color', '#db0096');
                }
            } else {
                alert(data);
            }
        }
    });
}
function check_2(id, _this) {
    var url = $('#D'+id).html();
    $.ajax({
        type: 'post',
        data:{url:url},
        url: "php/check_2.php",
        success: function(data) {
            if (data == 'YES') {
                $(_this).html('标记成功！');
                setTimeout(function () {
                    $(_this).html('标记：已对接');
                }, 1200);

                var color = $('#B'+id).css('color');
                if (color == 'rgb(3, 169, 244)') {
                    $('#B'+id).css('color', '#34495e');
                } else {
                    $('#B'+id).css('color', '#03a9f4');
                }
            } else {
                alert(data);
            }
        }
    });
}

$('#yes').html(<?php echo $yes;?>);
$('#no').html(<?php echo $no;?>);

$('#close').click(function(){
    $('.mask_div').hide();
});
var editor;
$('.ajax_api_btn').click(function(){
    $('.mask_div').show();
    $('.mask_content').html('');
    var api_root = $('#api_root').html();
    var api_title = $(this).parent().prev('h3').html();
    $('.mask_content').append('<div>请求接口：'+api_title+'</div>');
    var id = $(this).attr('data-id');
    var api_url = $('#'+id).html();
    $('.mask_content').append('<div>请求地址：<span id="api_url">'+api_url+'</span></div>');
    var api_param = $(this).parent().next('textarea').val();
    var data = api_param.slice(7).replace(';', '');
    $.ajax({
        type: 'post',
        data:{param:api_param},
        url: "index.php?status=ajax_param",
        success: function(data) {
            if (data == 'NO') {
                alert('/apiword/param.php 文件无写入权限，无法对param参数进行转换！');
            } else {
                var a = eval('('+data+')');
                $('.mask_content').append('<div>请求类型：<span id="api_post">'+a.header.method+'</span></div>');
                $('.mask_content').append('<div>数据类型：<span id="api_type">'+a.header['content-type']+'</span></div>');
                $('.mask_content').append('<div>数据编码：<span id="api_code">'+a.header.code+'</span></div>');
                $('.mask_content').append('<div>请求数据：</div>');
                $('.mask_content').append('<textarea id="ajax_content">'+JSON.stringify(a.param, null, 4)+'</textarea>');
                var json = {lineNumbers: true,mode: "text/javascript",styleActiveLine: true,theme: 'material',lineWrapping: true};
                editor = CodeMirror.fromTextArea(document.getElementById("ajax_content"), json);
                editor.setSize('85%', '100%');

                $('.mask_content').append('<div>返回值对照表：</div>');
                $('.mask_content').append('<textarea id="ajax_code">'+JSON.stringify(a.return, null, 4)+'</textarea>');
                var json = {lineNumbers: true,mode: "text/javascript",styleActiveLine: true,theme: 'material',lineWrapping: true};
                CodeMirror.fromTextArea(document.getElementById("ajax_code"), json).setSize('85%', '100%');

                $('.mask_content').append('<div><br/><button class="ajax_api_btn2" onclick="ajax_test()">立即调试</button><br/></div>');
                console.log(a);
            }
        }
    });
})
function ajax_test() {
    var api_root = $('#api_root').html();
    var api_url = $('#api_url').html();
    var url = api_root+api_url;
    var method = $('#api_post').html();
    var type = $('#api_type').html();
    var code = $('#api_code').html();
    console.log(editor);
    
    var data = jQuery.parseJSON(editor.getValue());
    
    $('.mask_content').append('<div>请求中...</div>');
    $.ajax({
        type: method,
        data:data,
        url: url,
        contentType: type+";charset="+code,
        success: function(data) {
            console.log(data);
            $('.mask_content').append('<div>请求成功...</div>');
            if (data == null || data=='' || data==undefined) {
                $('.mask_content').append('<div style="color:red">注意：接口无返回值！</div>');
            } else {
                var timestamp = Date.parse(new Date());
                $('.mask_content').append('<div>返回值：</div>');
                $('.mask_content').append('<textarea id="ajax_return_'+timestamp+'">'+JSON.stringify(eval('('+data+')'), null, 4)+'</textarea>');
                var json = {lineNumbers: true,mode: "text/javascript",styleActiveLine: true,theme: 'material',lineWrapping: true};
                CodeMirror.fromTextArea(document.getElementById("ajax_return_"+timestamp), json).setSize('85%', '100%');
            }
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            $('.mask_content').append('<div style="color:red">请求错误...</div>');
            $('.mask_content').append('<div style="color:red">状态码：'+XMLHttpRequest.status+'</div>');
            $('.mask_content').append('<div style="color:red">状态：'+XMLHttpRequest.readyState+'</div>');
            $('.mask_content').append('<div style="color:red">错误信息：'+textStatus+'</div>');
        }
    });

    
}
</script>

<?php } else { ?>
    
    <div style="width:100%;height:360px;background-color: #00b38a;"></div>
    <div style="width: 540px;height: 330px;border: 1px solid #eee;padding: 10px;position: absolute;top: 200px;left: 50%;margin-left: -270px;background: #fff;">
        <h1 style="padding: 30px 50px;"><?php echo TITLE;?></h1>
        <input type="password" id="pwd" placeholder="请输入密码" style="width: 90%;margin: 5%;border: 0;border-bottom: 1px solid #d2d2d2;padding-bottom: 15px;outline:none;font-size: 16px;">
        <button style="width: 90%;margin: 5%;height:50px;color: #fff;background-color: #00b38a;font-size: 18px;border: 0;" class="login">登陆</button>
    </div>
<?php } ?>
    </body>

</html>

<script>
<?php if (!empty($_SESSION['apiword'])) { ?>
// 代码高亮
var json = {lineNumbers: true,mode: "text/javascript",styleActiveLine: true,theme: 'material',lineWrapping: true};
<?php $num = 0;?>
<?php foreach( $list as $k=>$v) { ?>
<?php $num++;?>
<?php foreach( $v['list'] as $key=>$val) { ?>
<?php $num++;?>
CodeMirror.fromTextArea(document.getElementById("content<?php echo $num;?>"), json).setSize('100%', '100%');
<?php } ?>
<?php } ?>
<?php } ?>

// 获取接口已对接完成数
var i = 0;
$('.menu-sub li a').each(function(){
    var color = $(this).css('color');
    if (color == 'rgb(3, 169, 244)') {
        i++;
    }
})
$('#ok').html(i);

// 切换接口地址
$('#tab').click(function(){
    var display=$('.hide').css('display')
    if(display=='none'){
        $('.hide').show();
    }else{
        $('.hide').hide();
    }
})

// 退出登陆
$('#out').click(function(){
    $.ajax({
        type: 'post',
        data:{},
        url: "index.php?status=out",
        success: function(data) {
            alert(data);
            window.location.reload();
        }
    });
})

// 登陆
$('.login').click(function(){
    $.ajax({
        type: 'post',
        data:{
            'pwd':$('#pwd').val()
        },
        url: "index.php?status=login",
        success: function(data) {
            if (data == 1) {
                alert('登陆成功');
                window.location.reload();
            } else {
                alert('密码错误！');
            }
        }
    });
})

</script>